Index: /palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- /palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3346)
+++ /palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3347)
@@ -967,107 +485,105 @@
        REAL(wp) ::  r_dummy           !<
 
-       IF ( nesting_offline )  THEN
-!
-!--       Allocate arrays for geostrophic wind components. Arrays will 
-!--       incorporate 2 time levels in order to interpolate in between. Please
-!--       note, forcing using geostrophic wind components is only required in 
-!--       case of cyclic boundary conditions.
-          IF ( bc_lr_cyc  .AND.  bc_ns_cyc )  THEN
-             ALLOCATE( nest_offl%ug(0:1,nzb:nzt+1) )
-             ALLOCATE( nest_offl%vg(0:1,nzb:nzt+1) )
+       ALLOCATE( p_surf(0:nlsf), pt_surf(0:nlsf), q_surf(0:nlsf),              &
+                 qsws_surf(0:nlsf), shf_surf(0:nlsf),                          &
+                 td_lsa_lpt(nzb:nzt+1,0:nlsf), td_lsa_q(nzb:nzt+1,0:nlsf),     &
+                 td_sub_lpt(nzb:nzt+1,0:nlsf), td_sub_q(nzb:nzt+1,0:nlsf),     &
+                 time_vert(0:nlsf), time_surf(0:nlsf),                         &
+                 ug_vert(nzb:nzt+1,0:nlsf), vg_vert(nzb:nzt+1,0:nlsf),         &
+                 wsubs_vert(nzb:nzt+1,0:nlsf) )
+
+       p_surf = 0.0_wp; pt_surf = 0.0_wp; q_surf = 0.0_wp; qsws_surf = 0.0_wp
+       shf_surf = 0.0_wp; time_vert = 0.0_wp; td_lsa_lpt = 0.0_wp
+       td_lsa_q = 0.0_wp; td_sub_lpt = 0.0_wp; td_sub_q = 0.0_wp
+       time_surf = 0.0_wp; ug_vert = 0.0_wp; vg_vert = 0.0_wp
+       wsubs_vert = 0.0_wp
+
+!
+!--    Array for storing large scale forcing and nudging tendencies at each 
+!--    timestep for data output
+       ALLOCATE( sums_ls_l(nzb:nzt+1,0:7) )
+       sums_ls_l = 0.0_wp
+
+       ngp_sums_ls = (nz+2)*6
+
+       OPEN ( finput, FILE='LSF_DATA', STATUS='OLD', &
+              FORM='FORMATTED', IOSTAT=ierrn )
+
+       IF ( ierrn /= 0 )  THEN
+          message_string = 'file LSF_DATA does not exist'
+          CALL message( 'ls_forcing', 'PA0368', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       ierrn = 0
+!
+!--    First three lines of LSF_DATA contain header
+       READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
+       READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
+       READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
+
+       IF ( ierrn /= 0 )  THEN
+          message_string = 'errors in file LSF_DATA'
+          CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
+       ENDIF
+
+!
+!--    Surface values are read in
+       nt     = 0
+       ierrn = 0
+
+       DO WHILE ( time_surf(nt) < end_time )
+          nt = nt + 1
+          READ ( finput, *, IOSTAT = ierrn ) time_surf(nt), shf_surf(nt),      &
+                                             qsws_surf(nt), pt_surf(nt),       &
+                                             q_surf(nt), p_surf(nt)
+
+          IF ( ierrn /= 0 )  THEN
+            WRITE ( message_string, * ) 'No time dependent surface ' //        &
+                              'variables in & LSF_DATA for end of run found'
+
+             CALL message( 'ls_forcing', 'PA0363', 1, 2, 0, 6, 0 )
           ENDIF
-!
-!--       Allocate arrays for reading boundary values. Arrays will incorporate 2 
-!--       time levels in order to interpolate in between. 
-          IF ( bc_dirichlet_l )  THEN
-             ALLOCATE( nest_offl%u_left(0:1,nzb+1:nzt,nys:nyn)  )
-             ALLOCATE( nest_offl%v_left(0:1,nzb+1:nzt,nysv:nyn) )
-             ALLOCATE( nest_offl%w_left(0:1,nzb+1:nzt-1,nys:nyn) )
-             IF ( humidity )      ALLOCATE( nest_offl%q_left(0:1,nzb+1:nzt,nys:nyn)  )
-             IF ( .NOT. neutral ) ALLOCATE( nest_offl%pt_left(0:1,nzb+1:nzt,nys:nyn) )
-          ENDIF
-          IF ( bc_dirichlet_r )  THEN
-             ALLOCATE( nest_offl%u_right(0:1,nzb+1:nzt,nys:nyn)  )
-             ALLOCATE( nest_offl%v_right(0:1,nzb+1:nzt,nysv:nyn) )
-             ALLOCATE( nest_offl%w_right(0:1,nzb+1:nzt-1,nys:nyn) )
-             IF ( humidity )      ALLOCATE( nest_offl%q_right(0:1,nzb+1:nzt,nys:nyn)  )
-             IF ( .NOT. neutral ) ALLOCATE( nest_offl%pt_right(0:1,nzb+1:nzt,nys:nyn) )
-          ENDIF
-          IF ( bc_dirichlet_n )  THEN
-             ALLOCATE( nest_offl%u_north(0:1,nzb+1:nzt,nxlu:nxr) )
-             ALLOCATE( nest_offl%v_north(0:1,nzb+1:nzt,nxl:nxr)  )
-             ALLOCATE( nest_offl%w_north(0:1,nzb+1:nzt-1,nxl:nxr) )
-             IF ( humidity )      ALLOCATE( nest_offl%q_north(0:1,nzb+1:nzt,nxl:nxr)  )
-             IF ( .NOT. neutral ) ALLOCATE( nest_offl%pt_north(0:1,nzb+1:nzt,nxl:nxr) )
-          ENDIF
-          IF ( bc_dirichlet_s )  THEN
-             ALLOCATE( nest_offl%u_south(0:1,nzb+1:nzt,nxlu:nxr) )
-             ALLOCATE( nest_offl%v_south(0:1,nzb+1:nzt,nxl:nxr)  )
-             ALLOCATE( nest_offl%w_south(0:1,nzb+1:nzt-1,nxl:nxr)    )
-             IF ( humidity )      ALLOCATE( nest_offl%q_south(0:1,nzb+1:nzt,nxl:nxr)  )
-             IF ( .NOT. neutral ) ALLOCATE( nest_offl%pt_south(0:1,nzb+1:nzt,nxl:nxr) )
-          ENDIF
-          
-          ALLOCATE( nest_offl%u_top(0:1,nys:nyn,nxlu:nxr) )
-          ALLOCATE( nest_offl%v_top(0:1,nysv:nyn,nxl:nxr) )
-          ALLOCATE( nest_offl%w_top(0:1,nys:nyn,nxl:nxr)  )
-          IF ( humidity )      ALLOCATE( nest_offl%q_top(0:1,nys:nyn,nxl:nxr)  )
-          IF ( .NOT. neutral ) ALLOCATE( nest_offl%pt_top(0:1,nys:nyn,nxl:nxr) )
-
-!
-!--       Read COSMO data at lateral and top boundaries
-          CALL netcdf_data_input_lsf
-!
-!--       Write COSMO data at lateral and top boundaries
-          CALL lsf_nesting_offline
-!
-!--       After 3D data is initialized, ensure mass conservation
-          CALL lsf_nesting_offline_mass_conservation
-!
-!--       Initialize surface pressure. Please note, time-dependent surface
-!--       pressure would require changes in anelastic approximation and 
-!--       treatment of fluxes. 
-!--       For the moment, comment this out! 
-!         surface_pressure = nest_offl%surface_pressure(0)
-
-       ELSE
-
-          ALLOCATE( p_surf(0:nlsf), pt_surf(0:nlsf), q_surf(0:nlsf),           &
-                    qsws_surf(0:nlsf), shf_surf(0:nlsf),                       &
-                    td_lsa_lpt(nzb:nzt+1,0:nlsf), td_lsa_q(nzb:nzt+1,0:nlsf),  &
-                    td_sub_lpt(nzb:nzt+1,0:nlsf), td_sub_q(nzb:nzt+1,0:nlsf),  &
-                    time_vert(0:nlsf), time_surf(0:nlsf),                      &
-                    ug_vert(nzb:nzt+1,0:nlsf), vg_vert(nzb:nzt+1,0:nlsf),      &
-                    wsubs_vert(nzb:nzt+1,0:nlsf) )
-
-          p_surf = 0.0_wp; pt_surf = 0.0_wp; q_surf = 0.0_wp; qsws_surf = 0.0_wp
-          shf_surf = 0.0_wp; time_vert = 0.0_wp; td_lsa_lpt = 0.0_wp
-          td_lsa_q = 0.0_wp; td_sub_lpt = 0.0_wp; td_sub_q = 0.0_wp
-          time_surf = 0.0_wp; ug_vert = 0.0_wp; vg_vert = 0.0_wp
-          wsubs_vert = 0.0_wp
-
-!
-!--       Array for storing large scale forcing and nudging tendencies at each 
-!--       timestep for data output
-          ALLOCATE( sums_ls_l(nzb:nzt+1,0:7) )
-          sums_ls_l = 0.0_wp
-
-          ngp_sums_ls = (nz+2)*6
-
-          OPEN ( finput, FILE='LSF_DATA', STATUS='OLD', &
-                 FORM='FORMATTED', IOSTAT=ierrn )
-
-          IF ( ierrn /= 0 )  THEN
-             message_string = 'file LSF_DATA does not exist'
-             CALL message( 'ls_forcing', 'PA0368', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          ierrn = 0
-!
-!--       First three lines of LSF_DATA contain header
-          READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
-          READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
-          READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
-
+       ENDDO
+
+       IF ( time_surf(1) > end_time )  THEN
+          WRITE ( message_string, * ) 'Time dependent surface variables in ' //&
+                                      '&LSF_DATA set in after end of ' ,       &
+                                      'simulation - lsf_surf is set to FALSE'
+          CALL message( 'ls_forcing', 'PA0371', 0, 0, 0, 6, 0 )
+          lsf_surf = .FALSE.
+       ENDIF
+
+!
+!--    Go to the end of the list with surface variables
+       DO WHILE ( ierrn == 0 )
+          READ ( finput, *, IOSTAT = ierrn ) r_dummy
+       ENDDO
+
+!
+!--    Profiles of ug, vg and w_subs are read in (large scale forcing)
+
+       nt = 0
+       DO WHILE ( time_vert(nt) < end_time )
+          nt = nt + 1
+          hash = "#"
+          ierrn = 1 ! not zero
+!
+!--       Search for the next line consisting of "# time", 
+!--       from there onwards the profiles will be read
+          DO WHILE ( .NOT. ( hash == "#" .AND. ierrn == 0 ) ) 
+             READ ( finput, *, IOSTAT=ierrn ) hash, time_vert(nt)
+             IF ( ierrn < 0 )  THEN 
+                WRITE( message_string, * ) 'No time dependent vertical profiles',&
+                                 ' in & LSF_DATA for end of run found'
+                CALL message( 'ls_forcing', 'PA0372', 1, 2, 0, 6, 0 )
+             ENDIF
+          ENDDO
+
+          IF ( nt == 1 .AND. time_vert(nt) > end_time ) EXIT
+
+          READ ( finput, *, IOSTAT=ierrn ) lowheight, lowug_vert, lowvg_vert,  &
+                                           lowwsubs_vert, low_td_lsa_lpt,      &
+                                           low_td_lsa_q, low_td_sub_lpt,       &
+                                           low_td_sub_q
           IF ( ierrn /= 0 )  THEN
              message_string = 'errors in file LSF_DATA'
@@ -1075,146 +591,80 @@
           ENDIF
 
-!
-!--       Surface values are read in
-          nt     = 0
-          ierrn = 0
-
-          DO WHILE ( time_surf(nt) < end_time )
-             nt = nt + 1
-             READ ( finput, *, IOSTAT = ierrn ) time_surf(nt), shf_surf(nt),   &
-                                                qsws_surf(nt), pt_surf(nt),    &
-                                                q_surf(nt), p_surf(nt)
-
-             IF ( ierrn /= 0 )  THEN
-               WRITE ( message_string, * ) 'No time dependent surface ' //     &
-                                 'variables in & LSF_DATA for end of run found'
-
-                CALL message( 'ls_forcing', 'PA0363', 1, 2, 0, 6, 0 )
+          READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,            &
+                                           highvg_vert, highwsubs_vert,        &
+                                           high_td_lsa_lpt, high_td_lsa_q,     &
+                                           high_td_sub_lpt, high_td_sub_q
+       
+          IF ( ierrn /= 0 )  THEN
+             message_string = 'errors in file LSF_DATA'
+             CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
+          ENDIF
+
+
+          DO  k = nzb, nzt+1
+             IF ( highheight < zu(k) )  THEN
+                lowheight      = highheight
+                lowug_vert     = highug_vert
+                lowvg_vert     = highvg_vert
+                lowwsubs_vert  = highwsubs_vert
+                low_td_lsa_lpt = high_td_lsa_lpt
+                low_td_lsa_q   = high_td_lsa_q
+                low_td_sub_lpt = high_td_sub_lpt
+                low_td_sub_q   = high_td_sub_q
+
+                ierrn = 0
+                READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,      &
+                                                 highvg_vert, highwsubs_vert,  &
+                                                 high_td_lsa_lpt,              &
+                                                 high_td_lsa_q,                &
+                                                 high_td_sub_lpt, high_td_sub_q
+
+                IF ( ierrn /= 0 )  THEN
+                   WRITE( message_string, * ) 'zu(',k,') = ', zu(k), 'm ',     &
+                        'is higher than the maximum height in LSF_DATA ',      &
+                        'which is ', lowheight, 'm. Interpolation on PALM ',   &
+                        'grid is not possible.'
+                   CALL message( 'ls_forcing', 'PA0395', 1, 2, 0, 6, 0 )
+                ENDIF
+
              ENDIF
+
+!
+!--          Interpolation of prescribed profiles in space 
+             fac = (highheight-zu(k))/(highheight - lowheight)
+
+             ug_vert(k,nt)    = fac * lowug_vert                               &
+                                + ( 1.0_wp - fac ) * highug_vert
+             vg_vert(k,nt)    = fac * lowvg_vert                               &
+                                + ( 1.0_wp - fac ) * highvg_vert
+             wsubs_vert(k,nt) = fac * lowwsubs_vert                            &
+                                + ( 1.0_wp - fac ) * highwsubs_vert
+
+             td_lsa_lpt(k,nt) = fac * low_td_lsa_lpt                           &
+                                + ( 1.0_wp - fac ) * high_td_lsa_lpt
+             td_lsa_q(k,nt)   = fac * low_td_lsa_q                             &
+                                + ( 1.0_wp - fac ) * high_td_lsa_q
+             td_sub_lpt(k,nt) = fac * low_td_sub_lpt                           &
+                                + ( 1.0_wp - fac ) * high_td_sub_lpt
+             td_sub_q(k,nt)   = fac * low_td_sub_q                             &
+                                + ( 1.0_wp - fac ) * high_td_sub_q
+
           ENDDO
 
-          IF ( time_surf(1) > end_time )  THEN
-             WRITE ( message_string, * ) 'Time dependent surface variables in ' // &
-                                         '&LSF_DATA set in after end of ' ,        &
-                                         'simulation - lsf_surf is set to FALSE'
-             CALL message( 'ls_forcing', 'PA0371', 0, 0, 0, 6, 0 )
-             lsf_surf = .FALSE.
-          ENDIF
-
-!
-!--       Go to the end of the list with surface variables
-          DO WHILE ( ierrn == 0 )
-             READ ( finput, *, IOSTAT = ierrn ) r_dummy
-          ENDDO
-
-!
-!--       Profiles of ug, vg and w_subs are read in (large scale forcing)
-
-          nt = 0
-          DO WHILE ( time_vert(nt) < end_time )
-             nt = nt + 1
-             hash = "#"
-             ierrn = 1 ! not zero
-!
-!--          Search for the next line consisting of "# time", 
-!--          from there onwards the profiles will be read
-             DO WHILE ( .NOT. ( hash == "#" .AND. ierrn == 0 ) ) 
-                READ ( finput, *, IOSTAT=ierrn ) hash, time_vert(nt)
-                IF ( ierrn < 0 )  THEN 
-                   WRITE( message_string, * ) 'No time dependent vertical profiles',&
-                                    ' in & LSF_DATA for end of run found'
-                   CALL message( 'ls_forcing', 'PA0372', 1, 2, 0, 6, 0 )
-                ENDIF
-             ENDDO
-
-             IF ( nt == 1 .AND. time_vert(nt) > end_time ) EXIT
-
-             READ ( finput, *, IOSTAT=ierrn ) lowheight, lowug_vert, lowvg_vert,&
-                                              lowwsubs_vert, low_td_lsa_lpt,    &
-                                              low_td_lsa_q, low_td_sub_lpt,     &
-                                              low_td_sub_q
-             IF ( ierrn /= 0 )  THEN
-                message_string = 'errors in file LSF_DATA'
-                CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,         &
-                                              highvg_vert, highwsubs_vert,     &
-                                              high_td_lsa_lpt, high_td_lsa_q,  &
-                                              high_td_sub_lpt, high_td_sub_q
-         
-             IF ( ierrn /= 0 )  THEN
-                message_string = 'errors in file LSF_DATA'
-                CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
-             ENDIF
-
-
-             DO  k = nzb, nzt+1
-                IF ( highheight < zu(k) )  THEN
-                   lowheight      = highheight
-                   lowug_vert     = highug_vert
-                   lowvg_vert     = highvg_vert
-                   lowwsubs_vert  = highwsubs_vert
-                   low_td_lsa_lpt = high_td_lsa_lpt
-                   low_td_lsa_q   = high_td_lsa_q
-                   low_td_sub_lpt = high_td_sub_lpt
-                   low_td_sub_q   = high_td_sub_q
-
-                   ierrn = 0
-                   READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,    &
-                                                    highvg_vert, highwsubs_vert,&
-                                                    high_td_lsa_lpt,            &
-                                                    high_td_lsa_q,              &
-                                                    high_td_sub_lpt, high_td_sub_q
-
-                   IF ( ierrn /= 0 )  THEN
-                      WRITE( message_string, * ) 'zu(',k,') = ', zu(k), 'm ',  &
-                           'is higher than the maximum height in LSF_DATA ',   &
-                           'which is ', lowheight, 'm. Interpolation on PALM ',&
-                           'grid is not possible.'
-                      CALL message( 'ls_forcing', 'PA0395', 1, 2, 0, 6, 0 )
-                   ENDIF
-
-                ENDIF
-
-!
-!--             Interpolation of prescribed profiles in space 
-                fac = (highheight-zu(k))/(highheight - lowheight)
-
-                ug_vert(k,nt)    = fac * lowug_vert                            &
-                                   + ( 1.0_wp - fac ) * highug_vert
-                vg_vert(k,nt)    = fac * lowvg_vert                            &
-                                   + ( 1.0_wp - fac ) * highvg_vert
-                wsubs_vert(k,nt) = fac * lowwsubs_vert                         &
-                                   + ( 1.0_wp - fac ) * highwsubs_vert
-
-                td_lsa_lpt(k,nt) = fac * low_td_lsa_lpt                        &
-                                   + ( 1.0_wp - fac ) * high_td_lsa_lpt
-                td_lsa_q(k,nt)   = fac * low_td_lsa_q                          &
-                                   + ( 1.0_wp - fac ) * high_td_lsa_q
-                td_sub_lpt(k,nt) = fac * low_td_sub_lpt                        &
-                                   + ( 1.0_wp - fac ) * high_td_sub_lpt
-                td_sub_q(k,nt)   = fac * low_td_sub_q                          &
-                                   + ( 1.0_wp - fac ) * high_td_sub_q
-
-             ENDDO
-
-          ENDDO 
-
-!
-!--       Large scale vertical velocity has to be zero at the surface
-          wsubs_vert(nzb,:) = 0.0_wp
+       ENDDO 
+
+!
+!--    Large scale vertical velocity has to be zero at the surface
+       wsubs_vert(nzb,:) = 0.0_wp
     
-          IF ( time_vert(1) > end_time )  THEN
-             WRITE ( message_string, * ) 'Time dependent large scale profile ',&
-                                'forcing from&LSF_DATA sets in after end of ' ,&
-                                'simulation - lsf_vert is set to FALSE'
-             CALL message( 'ls_forcing', 'PA0373', 0, 0, 0, 6, 0 )
-             lsf_vert = .FALSE.
-          ENDIF
-
-          CLOSE( finput )
-
-       ENDIF
+       IF ( time_vert(1) > end_time )  THEN
+          WRITE ( message_string, * ) 'Time dependent large scale profile ',   &
+                             'forcing from&LSF_DATA sets in after end of ' ,   &
+                             'simulation - lsf_vert is set to FALSE'
+          CALL message( 'ls_forcing', 'PA0373', 0, 0, 0, 6, 0 )
+          lsf_vert = .FALSE.
+       ENDIF
+
+       CLOSE( finput )
 
     END SUBROUTINE lsf_init
